# `certbot.plugins.manual`

Manual authenticator plugin

class `certbot.plugins.manual.``ManualTlsSni01`(configurator)

  Bases: `certbot.plugins.common.TLSSNI01`

  TLS-SNI-01 authenticator for the Manual plugin

  Variables:

  - configurator – Authenticator object
  - achalls (list) – Annotated class:`KeyAuthorizationAnnotatedChallenge` challenges

  Parameters:

  - indices (list) – Meant to hold indices of challenges in a larger array. NginxTlsSni01 is capable of solving many challenges at once which causes an indexing issue within NginxConfigurator who must return all responses in order. Imagine NginxConfigurator maintaining state about where all of the http-01 Challenges, TLS-SNI-01 Challenges belong in the response array. This is an optional utility.
  - challenge_conf (str) – location of the challenge config file

  `perform`()

    Create the SSL certificates and private keys

class `certbot.plugins.manual.``Authenticator`(*args, **kwargs)

  Bases: `certbot.plugins.common.Plugin`

  Manual authenticator

  This plugin allows the user to perform the domain validation challenge(s) themselves. This either be done manually by the user or through shell scripts provided to Certbot.